<?php

$payload = "";

echo "Building groups of most common 1st bytes in adler32's 2 16bit hashing functions.\n";
$max = 0xfffff;
$common16bitPrefixes = array();
for ($i = 0; $i < $max; $i++) {
	$hash = hash_hmac('adler32', $payload, sha1(uniqid(true)));
	$hmac = substr($hash, 0, 2) . "%02x" . substr($hash, 4, 2) . "%02x";
	if (!array_key_exists($hmac, $common16bitPrefixes)) {
		$common16bitPrefixes[$hmac] = 0;
	}
	$common16bitPrefixes[$hmac]++;
}

arsort($common16bitPrefixes, SORT_NUMERIC);
echo "Built profile over $max iterations. " . count($common16bitPrefixes) . " common 1st bytes found.\n";
$runningTotal = 0;
$counter = 0;
foreach ($common16bitPrefixes as $hash => $hashCount) {
	$runningTotal += ($hashCount / $max) * 100;
	printf("%s : %d/%d (%f%% of the profiled adler32 hashes fall into this range, %f%% total hashes to this point) = %d requests to api.wordpress.org. %f%% of 32bit address space.\n",
		str_replace("%02x", "**", $hash), $hashCount, $max, ($hashCount / $max) * 100, $runningTotal, ++$counter * 0xffff,
		(($counter * 0xffff) / 0xffffffff) * 100);
}


foreach ($common16bitPrefixes as $key => $value) {
	$currentHashGroup = str_replace("%02x", "**", $key);
	echo "Testing hash group $currentHashGroup\n";
	for ($i = 0; $i <= 0xff; $i++) {
		for ($j = 0; $j <= 0xff; $j++) {
			$hash = sprintf($key, $i, $j);
			if ($hash == "10230310"){
				echo "found it!!";
				exit();
			}
		}
	}
}

